diff -urN /home/henrik/hobbit/release/hobbit-4.2.0/web/hobbit-confreport.c ./web/hobbit-confreport.c
--- /home/henrik/hobbit/release/hobbit-4.2.0/web/hobbit-confreport.c	2006-08-09 22:10:12.000000000 +0200
+++ ./web/hobbit-confreport.c	2006-10-03 12:56:57.000000000 +0200
@@ -8,7 +8,7 @@
 /*                                                                            */
 /*----------------------------------------------------------------------------*/
 
-static char rcsid[] = "$Id: hobbit-confreport.c,v 1.15 2006/05/31 16:12:38 henrik Rel $";
+static char rcsid[] = "$Id: hobbit-confreport.c,v 1.18 2006/08/19 06:25:27 henrik Exp $";
 
 #include <sys/types.h>
 #include <sys/stat.h>
@@ -45,6 +45,8 @@
 static char *coldelim = ";";
 static coltext_t *chead = NULL;
 static int ccount = 0;
+static int nkonly = 0;
+static int newnkconfig = 1;
 
 void errormsg(char *msg)
 {
@@ -131,6 +133,39 @@
 	closedir(d);
 }
 
+char *nkval(char *hname, char *tname, char *nkalerts)
+{
+	static char *result = NULL;
+
+	if (result) xfree(result);
+
+	if (newnkconfig) {
+		char *key;
+		nkconf_t *nkrec;
+
+		key = (char *)malloc(strlen(hname) + strlen(tname) + 2);
+		sprintf(key, "%s|%s", hname, tname);
+		nkrec = get_nkconfig(key, NKCONF_FIRSTMATCH, NULL);
+		if (!nkrec) {
+			result = strdup("No");
+		}
+		else {
+			char *tspec;
+
+			tspec = (nkrec->nktime ? timespec_text(nkrec->nktime) : "24x7");
+			result = (char *)malloc(strlen(tspec) + 30);
+			sprintf(result, "%s&nbsp;prio&nbsp;%d", tspec, nkrec->priority);
+		}
+		xfree(key);
+	}
+	else {
+		result = strdup((checkalert(nkalerts, tname) ? "Yes" : "No"));
+	}
+
+	return result;
+}
+
+
 static void print_host(hostlist_t *host, htnames_t *testnames[], int testcount)
 {
 	int testi, rowcount, netcount;
@@ -157,6 +192,7 @@
 	comment = bbh_item(hinfo, BBH_COMMENT);
 	description = bbh_item(hinfo, BBH_DESCRIPTION); 
 	net = bbh_item(hinfo, BBH_NET);
+	nkalerts = bbh_item(hinfo, BBH_NK);
 	nktime = bbh_item(hinfo, BBH_NKTIME); if (!nktime) nktime = "24x7"; else nktime = strdup(timespec_text(nktime));
 	downtime = bbh_item(hinfo, BBH_DOWNTIME); if (downtime) downtime = strdup(timespec_text(downtime));
 	reporttime = bbh_item(hinfo, BBH_REPORTTIME); if (!reporttime) reporttime = "24x7"; else reporttime = strdup(timespec_text(reporttime));
@@ -166,7 +202,7 @@
 	if (dispname || clientalias) rowcount++;
 	if (comment) rowcount++;
 	if (description) rowcount++;
-	if (nktime) rowcount++;
+	if (!newnkconfig && nktime) rowcount++;
 	if (downtime) rowcount++;
 	if (reporttime) rowcount++;
 
@@ -185,13 +221,11 @@
 	if (pagepathtitle) fprintf(stdout, "<tr><td>Monitoring location: %s</td></tr>\n", pagepathtitle);
 	if (comment) fprintf(stdout, "<tr><td>Comment: %s</td></tr>\n", comment);
 	if (description) fprintf(stdout, "<tr><td>Description: %s</td></tr>\n", description);
-	if (nktime) fprintf(stdout, "<tr><td>NK monitoring period: %s</td></tr>\n", nktime);
+	if (!newnkconfig && nktime) fprintf(stdout, "<tr><td>NK monitoring period: %s</td></tr>\n", nktime);
 	if (downtime) fprintf(stdout, "<tr><td>Planned downtime: %s</td></tr>\n", downtime);
 	if (reporttime) fprintf(stdout, "<tr><td>SLA Reporting Period: %s</td></tr>\n", reporttime);
 
 
-	nkalerts = bbh_item(hinfo, BBH_NK);
-
 	/* Build a list of the network tests */
 	itm = bbh_item_walk(hinfo);
 	while (itm) {
@@ -344,7 +378,7 @@
 		use_columndoc(testnames[testi]->name);
 		fprintf(stdout, "<tr>");
 		fprintf(stdout, "<td valign=top>%s</td>", testnames[testi]->name);
-		fprintf(stdout, "<td valign=top>%s</td>", (checkalert(nkalerts, testnames[testi]->name) ? "Yes" : "No"));
+		fprintf(stdout, "<td valign=top>%s</td>", nkval(host->hostname, testnames[testi]->name, nkalerts));
 
 		fprintf(stdout, "<td valign=top>");
 		if (twalk->b1 || twalk->b2 || twalk->b3) {
@@ -384,7 +418,7 @@
 		use_columndoc(testnames[testi]->name);
 		fprintf(stdout, "<tr>");
 		fprintf(stdout, "<td valign=top>%s</td>", testnames[testi]->name);
-		fprintf(stdout, "<td valign=top>%s</td>", (checkalert(nkalerts, testnames[testi]->name) ? "Yes" : "No"));
+		fprintf(stdout, "<td valign=top>%s</td>", nkval(host->hostname, testnames[testi]->name, nkalerts));
 		fprintf(stdout, "<td valign=top>-/-/-</td>");
 
 		/* Make up some default configuration data */
@@ -599,8 +633,8 @@
 {
 	int argi, hosti, testi;
 	char *pagepattern = NULL, *hostpattern = NULL;
-	char *envarea = NULL, *cookie = NULL, *p, *nexthost;
-	char hobbitcmd[1024], procscmd[1024], svcscmd[1024];
+	char *envarea = NULL, *cookie = NULL, *nexthost;
+	char *hobbitcmd, *procscmd, *svcscmd;
         int alertcolors, alertinterval;
 	char configfn[PATH_MAX];
 	char *respbuf = NULL, *procsbuf = NULL, *svcsbuf = NULL;
@@ -627,38 +661,50 @@
 			char *p = strchr(argv[argi], '=');
 			coldelim = strdup(p+1);
 		}
+		else if (strcmp(argv[argi], "--critical") == 0) {
+			nkonly = 1;
+		}
+		else if (strcmp(argv[argi], "--old-nk-config") == 0) {
+			newnkconfig = 0;
+		}
 	}
 
 	redirect_cgilog("hobbit-confreport");
 
-	/* Setup the filter we use for the report */
-	cookie = getenv("HTTP_COOKIE");
-	if (cookie && ((p = strstr(cookie, "pagepath=")) != NULL)) {
-		p += strlen("pagepath=");
-		pagepattern = strdup(p);
-		p = strchr(pagepattern, ';'); if (p) *p = '\0';
-		if (strlen(pagepattern) == 0) { xfree(pagepattern); pagepattern = NULL; }
-	}
+	load_hostnames(xgetenv("BBHOSTS"), NULL, get_fqdn());
+	load_nkconfig(NULL);
 
-	if (cookie && (!pagepattern) && ((p = strstr(cookie, "host=")) != NULL)) {
-		p += strlen("host=");
-		hostpattern = strdup(p);
-		p = strchr(hostpattern, ';'); if (p) *p = '\0';
-		if (strlen(hostpattern) == 0) { xfree(hostpattern); hostpattern = NULL; }
-	}
+	/* Setup the filter we use for the report */
+	cookie = get_cookie("pagepath"); if (cookie && *cookie) pagepattern = strdup(cookie);
+	cookie = get_cookie("host");     if (cookie && *cookie) hostpattern = strdup(cookie);
 
 	/* Fetch the list of host+test statuses we currently know about */
 	if (pagepattern) {
-		sprintf(hobbitcmd, "hobbitdboard page=%s fields=hostname,testname", pagepattern);
-		sprintf(procscmd,  "hobbitdboard page=%s test=procs fields=hostname,msg", pagepattern);
-		sprintf(svcscmd,   "hobbitdboard page=%s test=svcs fields=hostname,msg", pagepattern);
+		hobbitcmd = (char *)malloc(2*strlen(pagepattern) + 1024);
+		procscmd = (char *)malloc(2*strlen(pagepattern) + 1024);
+		svcscmd = (char *)malloc(2*strlen(pagepattern) + 1024);
+
+		sprintf(hobbitcmd, "hobbitdboard page=^%s$|^%s/.+ fields=hostname,testname", 
+			pagepattern, pagepattern);
+		sprintf(procscmd,  "hobbitdboard page=^%s$|^%s/.+ test=procs fields=hostname,msg",
+			pagepattern, pagepattern);
+		sprintf(svcscmd,   "hobbitdboard page=^%s$|^%s/.+ test=svcs fields=hostname,msg",
+			pagepattern, pagepattern);
 	}
 	else if (hostpattern) {
-		sprintf(hobbitcmd, "hobbitdboard host=%s fields=hostname,testname", hostpattern);
-		sprintf(procscmd,  "hobbitdboard host=%s test=procs fields=hostname,msg", hostpattern);
-		sprintf(svcscmd,   "hobbitdboard host=%s test=svcs fields=hostname,msg", hostpattern);
+		hobbitcmd = (char *)malloc(strlen(hostpattern) + 1024);
+		procscmd = (char *)malloc(strlen(hostpattern) + 1024);
+		svcscmd = (char *)malloc(strlen(hostpattern) + 1024);
+
+		sprintf(hobbitcmd, "hobbitdboard host=^%s$ fields=hostname,testname", hostpattern);
+		sprintf(procscmd,  "hobbitdboard host=^%s$ test=procs fields=hostname,msg", hostpattern);
+		sprintf(svcscmd,   "hobbitdboard host=^%s$ test=svcs fields=hostname,msg", hostpattern);
 	}
 	else {
+		hobbitcmd = (char *)malloc(1024);
+		procscmd = (char *)malloc(1024);
+		svcscmd = (char *)malloc(1024);
+
 		sprintf(hobbitcmd, "hobbitdboard fields=hostname,testname");
 		sprintf(procscmd,  "hobbitdboard test=procs fields=hostname,msg");
 		sprintf(svcscmd,   "hobbitdboard test=svcs fields=hostname,msg");
@@ -686,12 +732,20 @@
 	nexthost = respbuf;
 	do {
 		char *hname, *tname, *eoln;
+		int wanted = 1;
 
 		eoln = strchr(nexthost, '\n'); if (eoln) *eoln = '\0';
 		hname = nexthost;
 		tname = strchr(nexthost, '|'); if (tname) { *tname = '\0'; tname++; }
 
-		if (hname && tname && strcmp(hname, "summary") && strcmp(tname, xgetenv("INFOCOLUMN")) && strcmp(tname, xgetenv("TRENDSCOLUMN"))) {
+		if (nkonly) {
+			namelist_t *hinfo = hostinfo(hname);
+			char *nkalerts = bbh_item(hinfo, BBH_NK);
+
+			if (!nkalerts || (strcmp(nkval(hname, tname, nkalerts), "No") == 0)) wanted = 0;
+		}
+
+		if (wanted && hname && tname && strcmp(hname, "summary") && strcmp(tname, xgetenv("INFOCOLUMN")) && strcmp(tname, xgetenv("TRENDSCOLUMN"))) {
 			htnames_t *newitem = (htnames_t *)malloc(sizeof(htnames_t));
 
 			for (hwalk = hosthead; (hwalk && strcmp(hwalk->hostname, hname)); hwalk = hwalk->next);
@@ -726,7 +780,6 @@
 	qsort(&allhosts[0], hostcount, sizeof(hostlist_t **), host_compare);
 
 	/* Get the static info */
-	load_hostnames(xgetenv("BBHOSTS"), NULL, get_fqdn());
 	load_all_links();
 	init_tcp_services();
 	pingcolumn = xgetenv("PINGCOLUMN");
@@ -753,6 +806,9 @@
 		fprintf(stdout, "%s ", allhosts[hosti]->hostname);
 	}
 	fprintf(stdout, "</td></tr>\n");
+	if (nkonly) {
+		fprintf(stdout, "<tr><th valign=top align=left>Filter</th><td>Only data for the &quot;Critical Systems&quot; view reported</td></tr>\n");
+	}
 	fprintf(stdout, "</table>\n");
 
 	headfoot(stdout, "confreport", "", "front", COL_BLUE);
diff -urN /home/henrik/hobbit/release/hobbit-4.2.0/web/hobbit-enadis.c ./web/hobbit-enadis.c
--- /home/henrik/hobbit/release/hobbit-4.2.0/web/hobbit-enadis.c	2006-08-09 22:10:12.000000000 +0200
+++ ./web/hobbit-enadis.c	2006-10-03 12:55:27.000000000 +0200
@@ -289,21 +289,15 @@
 
 	if (cgi_method == CGI_GET) {
 		/*
-		 * It's a GET , so the initial request.
+		 * It's a GET, so the initial request.
 		 * If we have a pagepath cookie, use that as the initial
 		 * host-name filter.
 		 */
-		char *cookie, *p;
+		char *pagepath;
 
 		action = ACT_FILTER;
-
-		cookie = getenv("HTTP_COOKIE");
-		if (obeycookies && cookie && ((p = strstr(cookie, "pagepath=")) != NULL)) {
-			p += strlen("pagepath=");
-			pagepattern = strdup(p);
-			p = strchr(pagepattern, ';'); if (p) *p = '\0';
-			if (strlen(pagepattern) == 0) { xfree(pagepattern); pagepattern = 0; }
-		}
+		pagepath = get_cookie("pagepath");
+		if (obeycookies && pagepath && *pagepath) pagepattern = strdup(pagepath);
 	}
 
 	if (action == ACT_FILTER) {
@@ -312,6 +306,7 @@
 		load_hostnames(xgetenv("BBHOSTS"), NULL, get_fqdn());
 		sethostenv("", "", "", colorname(COL_BLUE), NULL);
 		sethostenv_filter(hostpattern, pagepattern, ippattern);
+		printf("Content-type: %s\n\n", xgetenv("HTMLCONTENTTYPE"));
 		showform(stdout, "maint", "maint_form", COL_BLUE, getcurrenttime(NULL), NULL, NULL);
 		return 0;
 	}
diff -urN /home/henrik/hobbit/release/hobbit-4.2.0/web/hobbit-hostgraphs.c ./web/hobbit-hostgraphs.c
--- /home/henrik/hobbit/release/hobbit-4.2.0/web/hobbit-hostgraphs.c	2006-08-09 22:10:13.000000000 +0200
+++ ./web/hobbit-hostgraphs.c	2006-10-03 12:55:27.000000000 +0200
@@ -209,24 +209,13 @@
 	fprintf(stdout, "Content-type: %s\n\n", xgetenv("HTMLCONTENTTYPE"));
 
 	if (action == A_SELECT) {
-                char *cookie, *p;
+                char *cookie;
 
-		cookie = getenv("HTTP_COOKIE");
-		if (cookie && !pagepattern && ((p = strstr(cookie, "pagepath=")) != NULL)) {
-			/* Match ONLY the exact pagename by using start/end of line markers */
-
-			p += strlen("pagepath=");
-			pagepattern = (char *)malloc(strlen(p) + 3);
-			sprintf(pagepattern, "^%s", p);
-			p = strchr(pagepattern, ';'); if (p) *p = '\0';
-
-			if (strlen(pagepattern) == 0) { 
-				xfree(pagepattern); 
-				pagepattern = NULL;
-			}
-			else {
-				strcat(pagepattern, "$");
-			}
+		cookie = get_cookie("pagepath");
+		if (!pagepattern && cookie && *cookie) {
+			/* Match the exact pagename and sub-pages */
+			pagepattern = (char *)malloc(10 + 2*strlen(cookie));
+			sprintf(pagepattern, "^%s$|^%s/.+", cookie, cookie);
 		}
 
 		if (hostpattern || pagepattern || ippattern)
diff -urN /home/henrik/hobbit/release/hobbit-4.2.0/web/hobbit-nkedit.c ./web/hobbit-nkedit.c
--- /home/henrik/hobbit/release/hobbit-4.2.0/web/hobbit-nkedit.c	2006-08-09 22:10:13.000000000 +0200
+++ ./web/hobbit-nkedit.c	2006-10-03 12:55:27.000000000 +0200
@@ -238,6 +238,7 @@
 	if (isaclone && isclonewarning) sprintf(warnmsg, "<SCRIPT LANGUAGE=\"Javascript\" type=\"text/javascript\"> alert('%s'); </SCRIPT>\n", isclonewarning);
 	if (hasclones && hascloneswarning) sprintf(warnmsg, "<SCRIPT LANGUAGE=\"Javascript\" type=\"text/javascript\"> alert('%s'); </SCRIPT>\n", hascloneswarning);
 
+	printf("Content-type: %s\n\n", xgetenv("HTMLCONTENTTYPE"));
 	showform(stdout, "nkedit", "nkedit_form", COL_BLUE, getcurrenttime(NULL), warnmsg, NULL);
 }
 
diff -urN /home/henrik/hobbit/release/hobbit-4.2.0/web/hobbit-nkview.c ./web/hobbit-nkview.c
--- /home/henrik/hobbit/release/hobbit-4.2.0/web/hobbit-nkview.c	2006-08-09 22:10:13.000000000 +0200
+++ ./web/hobbit-nkview.c	2006-10-03 12:55:27.000000000 +0200
@@ -46,8 +46,10 @@
 	char *bol, *eol;
 	time_t now;
 	char msg[1024];
+	int i;
 
-	sprintf(msg, "hobbitdboard color=red,yellow acklevel=%d fields=hostname,testname,color,lastchange,logtime,validtime,acklist", nkacklevel);
+	sprintf(msg, "hobbitdboard acklevel=%d fields=hostname,testname,color,lastchange,logtime,validtime,acklist color=%s", nkacklevel,colorname(mincolor));
+	for (i=mincolor+1; (i < COL_COUNT); i++) sprintf(msg+strlen(msg), ",%s", colorname(i));
 
 	hobbitdresult = sendmessage(msg, NULL, NULL, &board, 1, BBTALK_TIMEOUT);
 	if (hobbitdresult != BB_OK) {
diff -urN /home/henrik/hobbit/release/hobbit-4.2.0/web/hobbit-notifylog.c ./web/hobbit-notifylog.c
--- /home/henrik/hobbit/release/hobbit-4.2.0/web/hobbit-notifylog.c	1970-01-01 01:00:00.000000000 +0100
+++ ./web/hobbit-notifylog.c	2007-02-09 11:07:18.206269768 +0100
@@ -0,0 +1,138 @@
+/*----------------------------------------------------------------------------*/
+/* Hobbit notification log viewer                                             */
+/*                                                                            */
+/* Copyright (C) 2007 Henrik Storner <henrik@storner.dk>                      */
+/*                                                                            */
+/* This program is released under the GNU General Public License (GPL),       */
+/* version 2. See the file "COPYING" for details.                             */
+/*                                                                            */
+/*----------------------------------------------------------------------------*/
+
+static char rcsid[] = "$Id: hobbit-notifylog.c,v 1.2 2007/02/07 21:49:47 henrik Exp $";
+
+#include <limits.h>
+#include <stdio.h>
+#include <string.h>
+#include <stdlib.h>
+#include <ctype.h>
+#include <sys/types.h>
+#include <sys/stat.h>
+#include <dirent.h>
+#include <unistd.h>
+#include <fcntl.h>
+#include <errno.h>
+#include <time.h>
+
+#include "libbbgen.h"
+
+int	maxcount = 100;		/* Default: Include last 100 events */
+int	maxminutes = 1440;	/* Default: for the past 24 hours */
+char	*totime = NULL;
+char	*fromtime = NULL;
+char	*hostregex = NULL;
+char	*exhostregex = NULL;
+char	*testregex = NULL;
+char	*extestregex = NULL;
+char	*pageregex = NULL;
+char	*expageregex = NULL;
+char	*rcptregex = NULL;
+char	*exrcptregex = NULL;
+cgidata_t *cgidata = NULL;
+
+static void parse_query(void)
+{
+	cgidata_t *cwalk;
+
+	cwalk = cgidata;
+	while (cwalk) {
+		/*
+		 * cwalk->name points to the name of the setting.
+		 * cwalk->value points to the value (may be an empty string).
+		 */
+
+		if (strcasecmp(cwalk->name, "MAXCOUNT") == 0) {
+			maxcount = atoi(cwalk->value);
+		}
+		else if (strcasecmp(cwalk->name, "MAXTIME") == 0) {
+			maxminutes = atoi(cwalk->value);
+		}
+		else if (strcasecmp(cwalk->name, "FROMTIME") == 0) {
+			if (*(cwalk->value)) fromtime = strdup(cwalk->value);
+		}
+		else if (strcasecmp(cwalk->name, "TOTIME") == 0) {
+			if (*(cwalk->value)) totime = strdup(cwalk->value);
+		}
+		else if (strcasecmp(cwalk->name, "HOSTMATCH") == 0) {
+			if (*(cwalk->value)) hostregex = strdup(cwalk->value);
+		}
+		else if (strcasecmp(cwalk->name, "EXHOSTMATCH") == 0) {
+			if (*(cwalk->value)) exhostregex = strdup(cwalk->value);
+		}
+		else if (strcasecmp(cwalk->name, "TESTMATCH") == 0) {
+			if (*(cwalk->value)) testregex = strdup(cwalk->value);
+		}
+		else if (strcasecmp(cwalk->name, "EXTESTMATCH") == 0) {
+			if (*(cwalk->value)) extestregex = strdup(cwalk->value);
+		}
+		else if (strcasecmp(cwalk->name, "PAGEMATCH") == 0) {
+			if (*(cwalk->value)) pageregex = strdup(cwalk->value);
+		}
+		else if (strcasecmp(cwalk->name, "EXPAGEMATCH") == 0) {
+			if (*(cwalk->value)) expageregex = strdup(cwalk->value);
+		}
+		else if (strcasecmp(cwalk->name, "RCPTMATCH") == 0) {
+			if (*(cwalk->value)) rcptregex = strdup(cwalk->value);
+		}
+		else if (strcasecmp(cwalk->name, "EXRCPTMATCH") == 0) {
+			if (*(cwalk->value)) exrcptregex = strdup(cwalk->value);
+		}
+
+		cwalk = cwalk->next;
+	}
+}
+
+int main(int argc, char *argv[])
+{
+	int argi;
+	char *envarea = NULL;
+
+	for (argi=1; (argi < argc); argi++) {
+		if (argnmatch(argv[argi], "--env=")) {
+			char *p = strchr(argv[argi], '=');
+			loadenv(p+1, envarea);
+		}
+		else if (argnmatch(argv[argi], "--area=")) {
+			char *p = strchr(argv[argi], '=');
+			envarea = strdup(p+1);
+		}
+	}
+
+	redirect_cgilog("hobbit-notifylog");
+
+	fprintf(stdout, "Content-type: %s\n\n", xgetenv("HTMLCONTENTTYPE"));
+
+	cgidata = cgi_request();
+	if (cgidata == NULL) {
+		/* Present the query form */
+		sethostenv("", "", "", colorname(COL_BLUE), NULL);
+		showform(stdout, "notify", "notify_form", COL_BLUE, getcurrenttime(NULL), NULL, NULL);
+		return 0;
+	}
+
+	parse_query();
+	load_hostnames(xgetenv("BBHOSTS"), NULL, get_fqdn());
+
+	/* Now generate the webpage */
+	headfoot(stdout, "notify", "", "header", COL_GREEN);
+	fprintf(stdout, "<center>\n");
+	do_notifylog(stdout, maxcount, maxminutes, fromtime, totime, 
+			pageregex, expageregex, 
+			hostregex, exhostregex, 
+			testregex, extestregex,
+			rcptregex, exrcptregex);
+	fprintf(stdout, "</center>\n");
+	headfoot(stdout, "notify", "", "footer", COL_GREEN);
+
+	return 0;
+}
+
diff -urN /home/henrik/hobbit/release/hobbit-4.2.0/web/hobbit-notifylog.sh.DIST ./web/hobbit-notifylog.sh.DIST
--- /home/henrik/hobbit/release/hobbit-4.2.0/web/hobbit-notifylog.sh.DIST	1970-01-01 01:00:00.000000000 +0100
+++ ./web/hobbit-notifylog.sh.DIST	2007-02-09 11:07:23.802253102 +0100
@@ -0,0 +1,7 @@
+#!/bin/sh
+
+# This is the Hobbit wrapper for the notifylog CGI
+
+. @BBHOME@/etc/hobbitcgi.cfg
+@RUNTIMEDEFS@ exec @BBHOME@/bin/hobbit-notifylog.cgi $CGI_NOTIFYLOG_OPTS
+
diff -urN /home/henrik/hobbit/release/hobbit-4.2.0/web/hobbit-statusreport.c ./web/hobbit-statusreport.c
--- /home/henrik/hobbit/release/hobbit-4.2.0/web/hobbit-statusreport.c	2006-08-09 22:10:13.000000000 +0200
+++ ./web/hobbit-statusreport.c	2006-10-03 12:55:27.000000000 +0200
@@ -26,7 +26,7 @@
 {
 	char *envarea = NULL;
 	char *server = NULL;
-	char *cookie, *p, *pagefilter = "";
+	char *cookie, *pagefilter = "";
 	char *filter = NULL;
 	char *heading = NULL;
 	int  showcolors = 1;
@@ -108,13 +108,10 @@
 
 	if (!allhosts) {
       		/* Setup the filter we use for the report */
-		cookie = getenv("HTTP_COOKIE");
-		if (cookie && ((p = strstr(cookie, "pagepath=")) != NULL)) {
-			p += strlen("pagepath=");
-			pagefilter = malloc(strlen(p) + 6);
-			sprintf(pagefilter, "page=%s", p);
-			p = strchr(pagefilter, ';'); if (p) *p = '\0';
-			if (strlen(pagefilter) == 0) { xfree(pagefilter); pagefilter = ""; }
+		cookie = get_cookie("pagepath");
+		if (cookie && *cookie) {
+			pagefilter = malloc(10 + 2*strlen(cookie));
+			sprintf(pagefilter, "page=^%s$|^%s/.+", cookie, cookie);
 		}
 	}
 
diff -urN /home/henrik/hobbit/release/hobbit-4.2.0/web/hobbitgraph.c ./web/hobbitgraph.c
--- /home/henrik/hobbit/release/hobbit-4.2.0/web/hobbitgraph.c	2006-08-09 22:10:13.000000000 +0200
+++ ./web/hobbitgraph.c	2006-10-03 12:55:27.000000000 +0200
@@ -63,6 +63,7 @@
 int graphwidth = 0;
 int graphheight = 0;
 int ignorestalerrds = 0;
+int bgcolor = COL_GREEN;
 
 int coloridx = 0;
 char *colorlist[] = { 
@@ -216,6 +217,10 @@
 		else if (strcmp(cwalk->name, "nostale") == 0) {
 			ignorestalerrds = 1;
 		}
+		else if (strcmp(cwalk->name, "color") == 0) {
+			int color = parse_color(cwalk->value);
+			if (color != -1) bgcolor = color;
+		}
 
 		cwalk = cwalk->next;
 	}
@@ -440,8 +445,8 @@
 	  case ACT_MENU:
 		fprintf(output, "  <td align=\"left\"><img src=\"%s&amp;action=view&amp;graph=%s\" alt=\"%s graph\"></td>\n",
 			uri, grtype, grtype);
-		fprintf(output, "  <td align=\"left\" valign=\"top\"> <a href=\"%s&amp;graph=%s&amp;action=selzoom\"> <img src=\"%s/zoom.gif\" border=0 alt=\"Zoom graph\" style='padding: 3px'> </a> </td>\n",
-			uri, grtype, getenv("BBSKIN"));
+		fprintf(output, "  <td align=\"left\" valign=\"top\"> <a href=\"%s&amp;graph=%s&amp;action=selzoom&amp;color=%s\"> <img src=\"%s/zoom.gif\" border=0 alt=\"Zoom graph\" style='padding: 3px'> </a> </td>\n",
+			uri, grtype, colorname(bgcolor), getenv("BBSKIN"));
 		break;
 
 	  case ACT_SELZOOM:
@@ -538,8 +543,8 @@
 	else
 		p += sprintf(p, "?host=%s", hostname);
 
-	p += sprintf(p, "&amp;service=%s&amp;graph_height=%d&amp;graph_width=%d", 
-		     service, graphheight, graphwidth);
+	p += sprintf(p, "&amp;service=%s&amp;graph_height=%d&amp;graph_width=%d&amp;color=%s", 
+		     service, graphheight, graphwidth, colorname(bgcolor));
 	if (displayname != hostname) p += sprintf(p, "&amp;disp=%s", displayname);
 	if (firstidx != -1) p += sprintf(p, "&amp;first=%d", firstidx+1);
 	if (idxcount != -1) p += sprintf(p, "&amp;count=%d", idxcount);
@@ -548,8 +553,8 @@
 	switch (action) {
 	  case ACT_MENU:
 		fprintf(stdout, "Content-type: %s\n\n", xgetenv("HTMLCONTENTTYPE"));
-		sethostenv(displayname, "", service, colorname(COL_GREEN), hostname);
-		headfoot(stdout, "graphs", "", "header", COL_GREEN);
+		sethostenv(displayname, "", service, colorname(bgcolor), hostname);
+		headfoot(stdout, "graphs", "", "header", bgcolor);
 
 		fprintf(stdout, "<table align=\"center\" summary=\"Graphs\">\n");
 
@@ -560,13 +565,13 @@
 
 		fprintf(stdout, "</table>\n");
 
-		headfoot(stdout, "graphs", "", "footer", COL_GREEN);
+		headfoot(stdout, "graphs", "", "footer", bgcolor);
 		return 0;
 
 	  case ACT_SELZOOM:
 		fprintf(stdout, "Content-type: %s\n\n", xgetenv("HTMLCONTENTTYPE"));
-		sethostenv(displayname, "", service, colorname(COL_GREEN), hostname);
-		headfoot(stdout, "graphs", "", "header", COL_GREEN);
+		sethostenv(displayname, "", service, colorname(bgcolor), hostname);
+		headfoot(stdout, "graphs", "", "header", bgcolor);
 
 
 		fprintf(stdout, "  <div id='zoomBox' style='position:absolute; overflow:none; left:0px; top:0px; width:0px; height:0px; visibility:visible; background:red; filter:alpha(opacity=50); -moz-opacity:0.5; -khtml-opacity:0.5'></div>\n");
@@ -608,13 +613,13 @@
 		}
 
 
-		headfoot(stdout, "graphs", "", "footer", COL_GREEN);
+		headfoot(stdout, "graphs", "", "footer", bgcolor);
 		return 0;
 
 	  case ACT_SHOWZOOM:
 		fprintf(stdout, "Content-type: %s\n\n", xgetenv("HTMLCONTENTTYPE"));
-		sethostenv(displayname, "", service, colorname(COL_GREEN), hostname);
-		headfoot(stdout, "graphs", "", "header", COL_GREEN);
+		sethostenv(displayname, "", service, colorname(bgcolor), hostname);
+		headfoot(stdout, "graphs", "", "header", bgcolor);
 
 		fprintf(stdout, "<table align=\"center\" summary=\"Graphs\">\n");
 
@@ -622,7 +627,7 @@
 
 		fprintf(stdout, "</table>\n");
 
-		headfoot(stdout, "graphs", "", "footer", COL_GREEN);
+		headfoot(stdout, "graphs", "", "footer", bgcolor);
 		return 0;
 
 	  case ACT_VIEW:
diff -urN /home/henrik/hobbit/release/hobbit-4.2.0/web/hobbitsvc-info.c ./web/hobbitsvc-info.c
--- /home/henrik/hobbit/release/hobbit-4.2.0/web/hobbitsvc-info.c	2006-08-09 22:10:13.000000000 +0200
+++ ./web/hobbitsvc-info.c	2006-10-03 13:52:29.000000000 +0200
@@ -40,7 +40,7 @@
 	char *name;
 	int color;
 	char *dismsg;
-	time_t distime;
+	time_t distime, lastchange;
 	struct hinf_t *next;
 } hinf_t;
 hinf_t *tnames = NULL;
@@ -73,7 +73,7 @@
 	int testsz;
 	int haveuname = 0;
 
-	sprintf(hobbitcmd, "hobbitdboard fields=testname,color,disabletime,dismsg,client host=%s", hostname);
+	sprintf(hobbitcmd, "hobbitdboard fields=testname,color,disabletime,dismsg,client,lastchange host=^%s$", hostname);
 	if (sendmessage(hobbitcmd, NULL, NULL, &statuslist, 1, BBTALK_TIMEOUT) != BB_OK) {
 		return 1;
 	}
@@ -94,7 +94,8 @@
 			if (tok) { tnames[testcount].color = parse_color(tok); tok = gettok(NULL, "|"); }
 			if (tok) { tnames[testcount].distime = atol(tok); tok = gettok(NULL, "|"); }
 			if (tok) { tnames[testcount].dismsg = strdup(tok); tok = gettok(NULL, "|"); }
-			if (tok) { haveuname |= (*tok == 'Y'); }
+			if (tok) { haveuname |= (*tok == 'Y'); tok = gettok(NULL, "|"); }
+			if (tok) { tnames[testcount].lastchange = atol(tok); }
 			tnames[testcount].next = NULL;
 			testcount++;
 			if (testcount == testsz) {
@@ -113,7 +114,7 @@
 
 	/* Sort them so the display looks prettier */
 	qsort(&tnames[0], testcount, sizeof(hinf_t), test_name_compare);
-	xfree(statuslist); statuslist = NULL;
+	if (statuslist) xfree(statuslist); statuslist = NULL;
 
 
 	sprintf(hobbitcmd, "schedule");
@@ -241,6 +242,108 @@
 }
 
 
+static void generate_hobbit_statuslist(char *hostname, strbuffer_t *buf)
+{
+	char msgline[4096];
+	char datestr[100];
+	int i, btncount;
+	char *bbdatefmt;
+	strbuffer_t *servRed, *servYellow, *servPurple, *servBlue;
+	time_t logage;
+
+	bbdatefmt = xgetenv("BBDATEFORMAT");
+
+	servRed = newstrbuffer(0);
+	servYellow = newstrbuffer(0);
+	servPurple = newstrbuffer(0);
+	servBlue = newstrbuffer(0);
+
+	addtobuffer(buf, "<tr><th align=left valign=top>Status summary</th><td align=left>\n");
+	addtobuffer(buf, "<form name=\"colorsel\" action=\"nosubmit\" method=\"GET\">\n");
+	addtobuffer(buf, "<table summary=\"Status summary\" border=1>\n");
+	addtobuffer(buf, "<tr><th>Service</th><th>Since</th><th>Duration</th></tr>\n");
+
+	for (i = 0; i < testcount; i++) {
+		strftime(datestr, sizeof(datestr), bbdatefmt, localtime(&tnames[i].lastchange));
+		logage = time(NULL) - tnames[i].lastchange;
+
+		addtobuffer(buf, "<tr>");
+
+		sprintf(msgline, "<td><img src=\"%s/%s\" height=\"%s\" width=\"%s\" border=0 alt=\"%s status\"> %s</td>",
+			xgetenv("BBSKIN"), dotgiffilename(tnames[i].color, 0, 1),
+			xgetenv("DOTHEIGHT"), xgetenv("DOTWIDTH"),
+			colorname(tnames[i].color), tnames[i].name);
+		addtobuffer(buf, msgline);
+
+		sprintf(msgline, "<td>%s</td>", datestr);
+		addtobuffer(buf, msgline);
+
+		sprintf(msgline, "<td align=right>%d days, %02d hours, %02d minutes</td>",
+			(int)(logage / 86400),(int) ((logage % 86400) / 3600),(int) ((logage % 3600) / 60));
+		addtobuffer(buf, msgline);
+
+		addtobuffer(buf, "</tr>\n");
+
+		sprintf(msgline, ",%s", tnames[i].name);
+		switch (tnames[i].color) {
+		  case COL_BLUE   : addtobuffer(servBlue, msgline);   break;
+		  case COL_RED    : addtobuffer(servRed, msgline);    break;
+		  case COL_YELLOW : addtobuffer(servYellow, msgline); break;
+		  case COL_PURPLE : addtobuffer(servPurple, msgline); break;
+		}
+	}
+
+	btncount = 0;
+	if (STRBUFLEN(servRed) > 0)    btncount++;
+	if (STRBUFLEN(servYellow) > 0) btncount++;
+	if (STRBUFLEN(servPurple) > 0) btncount++;
+	if (STRBUFLEN(servBlue) > 0)   btncount++;
+	if (btncount > 0) {
+		addtobuffer(buf, "<tr><td colspan=3>\n");
+
+		addtobuffer(buf, "<table width=\"100%\">\n");
+		sprintf(msgline, "<tr><th colspan=%d><center><i>Toggle tests to disable</i></center></th></tr>\n", btncount);
+		addtobuffer(buf, msgline);
+
+		addtobuffer(buf, "<tr>\n");
+		if (STRBUFLEN(servRed) > 0) {
+			addtobuffer(buf, "<td align=center><input type=button value=\"Toggle red\" onClick=\"mark4Disable('");
+			addtostrbuffer(buf, servRed);
+			addtobuffer(buf, ",');\"></td>\n");
+		} 
+		if (STRBUFLEN(servYellow) > 0) {
+			addtobuffer(buf, "<td align=center><input type=button value=\"Toggle yellow\" onClick=\"mark4Disable('");
+			addtostrbuffer(buf, servYellow);
+			addtobuffer(buf, ",');\"></td>\n");
+		} 
+		if (STRBUFLEN(servPurple) > 0) {
+			addtobuffer(buf, "<td align=center><input type=button value=\"Toggle purple\" onClick=\"mark4Disable('");
+			addtostrbuffer(buf, servPurple);
+			addtobuffer(buf, ",');\"></td>\n");
+		} 
+		if (STRBUFLEN(servBlue) > 0) {
+			addtobuffer(buf, "<td align=center><input type=button value=\"Toggle blue\" onClick=\"mark4Disable('");
+			addtostrbuffer(buf, servBlue);
+			addtobuffer(buf, ",');\"></td>\n");
+		} 
+
+		addtobuffer(buf, "</tr>\n");
+		addtobuffer(buf, "</table>\n");
+
+		addtobuffer(buf,"</td></tr>\n");
+
+	}
+
+	addtobuffer(buf,"</table></form>\n");
+	addtobuffer(buf, "</td></tr>\n");
+	addtobuffer(buf, "<tr><td colspan=2>&nbsp;</td></tr>\n");
+
+	freestrbuffer(servRed);
+	freestrbuffer(servYellow);
+	freestrbuffer(servPurple);
+	freestrbuffer(servBlue);
+}
+
 static void generate_hobbit_disable(char *hostname, strbuffer_t *buf)
 {
 	int i;
@@ -256,7 +359,7 @@
 	beginyear = nowtm->tm_year + 1900;
 	endyear = nowtm->tm_year + 1900 + 5;
 
-	sprintf(l, "<form method=\"post\" action=\"%s/hobbit-enadis.sh\">\n", xgetenv("SECURECGIBINURL"));
+	sprintf(l, "<form name=\"disableform\" method=\"post\" action=\"%s/hobbit-enadis.sh\">\n", xgetenv("SECURECGIBINURL"));
 	addtobuffer(buf, l);
 	sprintf(l, "<table summary=\"%s disable\" border=1>\n", hostname);
 	addtobuffer(buf, l);
@@ -266,7 +369,18 @@
 	addtobuffer(buf, "<td rowspan=2><select multiple size=\"15\" name=\"disabletest\">\n");
 	addtobuffer(buf, "<option value=\"*\">ALL</option>\n");
 	for (i=0; (i < testcount); i++) {
-		sprintf(l, "<option value=\"%s\">%s</option>\n", tnames[i].name, tnames[i].name);
+		char *colstyle;
+		switch (tnames[i].color) {
+		  case COL_RED:	   colstyle = "color: red"; break;
+		  case COL_YELLOW: colstyle = "color: #FFDE0F"; break;
+		  case COL_GREEN:  colstyle = "color: green"; break;
+		  case COL_BLUE:   colstyle = "color: blue;"; break;
+		  case COL_PURPLE: colstyle = "color: fuchsia;"; break;
+		  default:         colstyle = "color: black;"; break;
+		}
+
+		sprintf(l, "<option value=\"%s\" style=\"%s\">%s</option>\n", 
+			tnames[i].name, colstyle, tnames[i].name);
 		addtobuffer(buf, l);
 	}
 	addtobuffer(buf, "</select></td>\n");
@@ -544,7 +658,7 @@
 	if (strcmp(val, "0.0.0.0") == 0) {
 		struct in_addr addr;
 		struct hostent *hent;
-		static char hostip[IP_ADDR_STRLEN];
+		static char hostip[IP_ADDR_STRLEN + 20];
 
 		hent = gethostbyname(hostname);
 		if (hent) {
@@ -809,6 +923,7 @@
 	if (gotstatus && showenadis) {
 		int i, anydisabled = 0;
 
+		generate_hobbit_statuslist(hostname, infobuf);
 		addtobuffer(infobuf, "<tr><th align=left valign=top>Disable tests</th><td align=left>\n");
 		generate_hobbit_disable(hostname, infobuf);
 		addtobuffer(infobuf, "</td></tr>\n");
